package org.resteasy.test;

import org.junit.Assert;
import org.junit.Test;

import javax.ws.rs.ProcessingException;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.core.Response;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class MyTest {
    @Test
    public void testBuildResponse() throws Exception {
        Client client = ClientBuilder.newClient();

        Response response = client.target("http://localhost:8080/jaxrs-wfly/nothing").request().get();
        int code = response.getStatus();
        Assert.assertEquals(304, code);
        if (code == 200) {
            InputStream is = response.readEntity(InputStream.class);
            Assert.assertEquals("hello", readString(is));
        }
        else if (code == 304) {
            try {
                response.readEntity(InputStream.class);
                Assert.fail("ProcessingException was not thrown");
            } catch (ProcessingException e) {
                e.printStackTrace();
            }
        }
        else {
            Assert.fail("Wrong code");
        }
        response.close();
    }


    /**
     * Convert input stream to String.
     *
     * @param in Input stream
     * @return Converted string
     */
    public static String readString(final InputStream in) throws IOException {
        char[] buffer = new char[1024];
        StringBuilder builder = new StringBuilder();
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        int wasRead = 0;
        do {
            wasRead = reader.read(buffer, 0, 1024);
            if (wasRead > 0) {
                builder.append(buffer, 0, wasRead);
            }
        }
        while (wasRead > -1);

        return builder.toString();
    }
}
